/**
 * @file
 */

(function ($) {
  Drupal.behaviors.exampleModule = {
    attach: function (context, settings) {

      'use strict';

      /* App Module */

      angular.element(document).ready(function () {
        angular.bootstrap(document, ['myapp']);
      });

      var myApp = angular.module('myapp', [
        'myControllers'
      ]);

      var myControllers = angular.module('myControllers', ['ngSanitize']);

      myControllers.controller('myContrBasic', ['$scope', '$http',
        function ($scope, $http) {

          $scope.isLoading = true;
          $scope.perpage = '5000';
          $scope.toggle = true;

          $http.get(Drupal.settings.basePath + 'dblog_quick_filter/get_dblog',
            {
              params: {
                page: $scope.perpage
              }
            }
          ).success(function (data) {

            $scope.tbItems = data;
            $scope.filterLOG = data.rows;
            $scope.isLoading = false;
          });

          $scope.perPage = function () {
            $scope.isLoading = true;
            $http.get(Drupal.settings.basePath + 'dblog_quick_filter/get_dblog',
              {
                params: {
                  page: $scope.perpage
                }
              }
            ).success(function (data) {
              $scope.tbItems = data;
              $scope.filterLOG = data.rows;

              $scope.isLoading = false;
            });

          };

          $scope.checkMe = function (data) {
            if (data.class == null) {
              return data;
            }
            else {
              return '';
            }
          };

          $scope.magikFilterQuery = function (item) {
            var term;
            var part;
            if (angular.isUndefined($scope.query) === false) {
              if ($scope.matchcase === true) {
                term = item.data[3];
                part = $scope.query;
              }
              else {
                term = angular.lowercase(item.data[3]);
                part = angular.lowercase($scope.query);
              }
              if (term.indexOf(part) === -1) {
                return false;
              }
              else {
                return true;
              }
            }
            else {
              return true;
            }
          };

          $scope.magikFilterType = function (item) {
            if (angular.isUndefined($scope.type) === false) {
              if ($scope.type.indexOf(item.data[1]) !== -1) {
                return true;
              }
              else {
                return false;
              }
            }
            else {
              return true;
            }
          };

          $scope.magikFilterSeverity = function (item) {
            if (angular.isUndefined($scope.severity) === false) {
              if ($scope.severity.indexOf(item.data[6]) !== -1) {
                return true;
              }
              else {
                return false;
              }
            }
            else {
              return true;
            }
          };

          $scope.magikFilterUser = function (item) {
            if (angular.isUndefined($scope.user) === false) {
              if ($scope.user.length === 1 && item.data[4].indexOf($scope.user) !== -1) {
                return true;
              }
              else if ($scope.user.length > 1) {

                for (var i = 0; i <= $scope.user.length; i++) {

                  if (angular.isUndefined($scope.user[i]) === false) {

                    if (item.data[4].indexOf($scope.user[i]) !== -1) {

                      return true;
                    }
                    if (i === $scope.user.length) {
                      return false;
                    }
                  }
                }
              }
              else {
                return false;
              }
            }
            else {
              return true;
            }
          };

          $scope.detView = function (context, wid) {

            if (context.toggle === true) {

              $scope.isLoading = true;
              $http.get(Drupal.settings.basePath + 'dblog_quick_filter/get_event/' + wid)
                  .success(function (data) {
                    angular.element('#' + wid + ' > td').html(data.data);
                    context.toggle = !context.toggle;
                    $scope.isLoading = false;
                  });
            }
            else {

              context.toggle = !context.toggle;
            }
          };

          $scope.clearFilter = function (inst) {

            if (inst === 'all') {

              $scope.query = '';
              $scope.type = undefined;
              $scope.severity = undefined;
              $scope.user = undefined;
            }
            else if (angular.isString($scope[inst])) {

              $scope[inst] = '';
            }
            else if (angular.isArray($scope[inst])) {

              $scope[inst] = undefined;
            }

            return true;
          };
        }
      ]);

    }
  };
}(jQuery));
